//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#include <stdio.h>

#include "Unit1.h"
#include "Unit2.h"
#include "Unit3.h"
#include "Unit4.h"
#include "Unit5.h"
#include "Unit6.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
_WIN32_FIND_DATAW GFileData;
int Flg,M_FLG,DUP_CNT,Err;
String PATH0,PATH1,EXT,FNAME,Vol;
unsigned char *ucBuf,*ucBuf1;
DWORD dwLen;
char kamma[30];
int IconX,IconY,IconFlg;

void icon_disp(String fname)
{
  String ext;
  Graphics::TBitmap *bmp;
  HICON hIcon;
  TIcon	*Icon;

  ext=ExtractFileExt(fname);
  ext=ext.LowerCase();


  Form1->Image1->Visible=true;

  bmp=new Graphics::TBitmap;
  Icon=new TIcon;

  bmp->Width=Icon->Width+1;
  bmp->Height =Icon->Height+1;

  Form1->Image1->Canvas->StretchDraw(Rect(1,1,56,56),bmp);
  Form1->Image1->Refresh();

  if(ext==".ico")
   {
	Icon->LoadFromFile(fname);

	bmp->Width=Icon->Width+1;
	bmp->Height =Icon->Height+1;
	IconX=Icon->Width;
	IconY=Icon->Height;
	IconFlg=255;

	 hIcon=Icon->Handle;

	 HDC hdc=bmp->Canvas->Handle;
	 DrawIcon(hdc,0,0,hIcon);

	 Form1->Image1->Canvas->StretchDraw(Rect(1,1,56,56),bmp);

   }
  else
   {  IconFlg=0;
	  IconX=0;
	  IconY=0;

	  if((ext==".exe")||(ext==".dll"))
	   {
		ExtractIconEx(fname.c_str(),0,&hIcon,NULL,1);

		Icon->Handle = hIcon;

		bmp->Width=Icon->Width+1;
		bmp->Height =Icon->Height+1;

		HDC hdc=bmp->Canvas->Handle;
		DrawIcon(hdc,0,0,hIcon);

		Form1->Image1->Canvas->StretchDraw(Rect(1,1,56,56),bmp);

		if(Form1->CheckBox3->Checked==true)
		  { Icon->SaveToFile("D:\\tmp.ico"); }
	   }

   }

  delete bmp;
  delete Icon;

  //Icon->ReleaseHandle();
  // DestroyIcon(hIcon);
}

int conv_e(AnsiString fname)
{
 DWORD i;
 unsigned char c1,c2;
 ucBuf1=new unsigned char[dwLen+1];

 for(i=0;i<dwLen;i++)
 {

  c1=c2=0;
  c1=ucBuf[i];
  c2=ucBuf[i+1];

  if(c1>=0x80)
   {
     c1=c1-0x80;
     c2=c2-0x80;

     if(c1%2)
      {
       c1=((c1+1)/2)+0x70;
       c2=c2+0x1f;
      }
     else
      {
       c1=(c1/2)+0x70;
       c2=c2+0x7d;
      }

     if(c1>=0xa0)
      { c1=c1+0x40;  }

     if(c2>=0x7f)
      { c2=c2+1; }

     ucBuf1[i]=c1;
     ucBuf1[i+1]=c2;
     i++;
   }
  else
   {
     ucBuf1[i]=c1;
   }

 }
 AnsiString f=ChangeFileExt(fname,".euc");

 FILE *fp;
 WIN32_FIND_DATA dat;
 int l;

 fp=fopen(f.c_str(),"wb");

 if(fp==0) return -1;

 fwrite(ucBuf1,dwLen,1,fp);

 fclose(fp);

 delete ucBuf1;
 return 1;
}


int conv_utf(AnsiString fname,int flg=4) //utf8->shiftJis
{
 int handle,len;
 AnsiString s;

 if(flg==4)    //  utf8->shiftJis
  {                             //C++Builder10.2ŋ@\
   s=Utf8ToAnsi((char *)ucBuf); //0d,0ȁꍇ͑ʖ(0a only)
   len=s.Length();
   if(len==0)
    {
     ShowMessage("sR|h0`݂̂łȂƁCUtf8ToAnsi()삵Ȃ悤ł");
     return -1;
    }
  }
 else         //  shiftJis ->utf8
  {
   s=AnsiToUtf8((char *)ucBuf);  //C++Builder10.2ł͋@\H

   len=s.Length();
   if(len==0)
    {
	 ShowMessage("sR|h0`݂̂łȂƁCUtf8ToAnsi()삵Ȃ悤ł");
     return -1;
    }
  }

 AnsiString f;

 if(flg==4)
    f=ChangeFileExt(fname,".sjis");
 else
    f=ChangeFileExt(fname,".utf");

 handle=FileCreate(f);
 if(handle<0)
  {
   return -1; }

 FileWrite(handle, s.c_str(), len);
 FileClose(handle);
 return 1;
}
AnsiString mega_conv(float size)
{
  AnsiString w,w1;
  float s;
  int p;

  if(size<1000)
   {s=size;
	p=0;
	w1=" B";
   }
  else
   if(size>999999999) //giga
	{
	 s=((float)size)/1073741824;
	 p=FloatToStr(s).Pos(".");
	 w1=" GB";
	}
   else
	{
	 if(size>999999) //MByte
	  {
	   s=size/1048576;
	   p=FloatToStr(s).Pos(".");
	   w1=" MB";
	  }
	 else
	  {
	   s=size/1024;
	   p=FloatToStr(s).Pos(".");
	   w1=" KB";
	  }
	}

  if(p>0)
	w=FloatToStr(s).SubString(1,p+2)+w1;
  else
	w=FloatToStr(s)+w1;

  return w;
}

#define giga 1000000000.0
#define mega 1000000
#define kilo 1000

void  cov(float d)
{  int d0,d1,d2,d3;
   float r1,r2;

  d0=d/giga;
  r1=d-d0*giga;
  d1=(r1/mega);
  r2=r1-d1*mega;

  d2=r2/kilo;
  d3=r2-d2*kilo;

  if(d0 !=0)
   { sprintf(kamma,"%d,%03d,%03d,%03d Byte",d0,d1,d2,d3); }  //giga
  else
   if(d1==0)
	if(d2==0)
	 {sprintf(kamma,"%d Byte",d3); }
	else
	{sprintf(kamma,"%d,%03d Byte",d2,d3);} //kilo
   else
	{ sprintf(kamma,"%d,%03d,%03d Byte",d1,d2,d3); } //mega
  return;
}
#undef giga;
#undef mega;
#undef kilo;

//---------------------------------------------------------------


int GetDrvInfo(String &drv);

void conv_d(AnsiString fname,int flg)
{
 FILE *fp;     //#include <stdio.h>Kv
 WIN32_FIND_DATA dat;
 unsigned char c;
 AnsiString fname1,ext,path;
 ext=ExtractFileExt(fname);
 path=ExtractFilePath(fname);
 fname1=ExtractFileName(fname);
 fname=fname1.SubString(1,fname1.Length()-ext.Length());
 fname=fname+"00"+ext;

 ucBuf1=new unsigned char[dwLen*2+1];
 int p=0,len,typ1;

 Form1->ProgressBar1->Visible=true;
 Form1->ProgressBar1->Position=0;
 Form1->ProgressBar1->Max=dwLen;



 for(unsigned int i=0;i<dwLen;i++)
  {
   c=ucBuf[i];
  //2byteR|hl̕Kv
  typ1=0;

  if(_ismbslead(ucBuf, ucBuf+i) !=0)
	{  typ1=1;   }

   switch(flg)
	{
	  case 0:  //cut 0dh
	   if(c != 0xd)
		{   ucBuf1[p++]=c;  }
	   break;

	  case 1: //cut esc
	   if(c==0x1b)
		 {    flg=255;     }
	   else
		 {
		   if(flg==255)
			 {
			   if(c=='m')
				{  flg=0;    }
			 }
		   else
			{  ucBuf1[p++]=c;   }
		 }
	   break;

	  case 2:  //cut bs
	   if(c != 0x8)
		 {
		   ucBuf1[p++]=c;
		   if(typ1==1)
			{
			  if(ucBuf[i+2] !='\b')
			   {
				ucBuf1[p++]=ucBuf[++i];
			   }
			  else //2byte code
			   {
				 i++;
			   }
			}
		 }

	   else
		 {
		  p--;

		  if(p<0) p=0;
		 }
		break;
	  case 3:    //0d 0a
		if( c !=0x0a )
		 {  ucBuf1[p++]=c;     }
		else
		 {
		  ucBuf1[p++]=0x0d;
		  ucBuf1[p++]=0x0a;
		 }
		break;
   }

   Form1->ProgressBar1->Position=i;
   Application->ProcessMessages();

  }

 fp=fopen(fname.c_str(),"w+b");
 if(fp !=NULL)
  {
   fwrite(ucBuf1,p,1,fp);
   fclose(fp);
  }
 else
  {
	Application->MessageBox(L"qn@̂悤ł",L"x",0);
  }
 delete ucBuf1;
 Form1->ProgressBar1->Visible=false;
 Form1->FileListBox1->Update();

}


void conv(int flg)
{
 FILE *fp;
 TSearchRec ts;
 int i,total,done,eflg;
 AnsiString path,fname;
 String msg;

 Screen->Cursor=crSQLWait;
 eflg=0;

 switch(flg)
  {
   case 0:
	msg="@t@C0DH 폜܂","";
	break;
   case 1:

	break;
   case 2: //BS CUT

	break;

   case 3:
	msg="@t@C0A->0D0A ϊ܂","";
	break;

   case 4:
	msg="@t@Cutf8ShiftJisɕϊ܂","";
	break;
   case 5:
	msg="@t@CShiftJisutf8ɕϊ܂","";
	break;
   case 6:
	msg="@t@CEUC-JPShiftJisɕϊ܂","";
	break;

   default:
	return;
  }


 done=0;
 total=Form1->FileListBox1->Items->Count;
 path=Form1->Label8->Caption;

 for(i=0;i<total;i++)
  {
   if(Form1->FileListBox1->Selected[i]==true)
	{
	 fname=Form1->FileListBox1->Items->Strings[i];
	 fname=path+fname;

//	String  s;
// 	Form1->Memo1->Lines->LoadFromFile(fname);//ǂݍ


	FindFirst(fname,faAnyFile,ts);
	dwLen=ts.Size;
	fp=fopen(fname.c_str(),"rb");


	try{
	  ucBuf=new unsigned char[dwLen+1];
	  fread(ucBuf,dwLen+1,1,fp); }
	catch(...)
	  {
	  Application->MessageBox(L"t@C傫߂܂",L"",0);
	   eflg=255;
	  }

	fclose(fp);

	if(flg<4)
	 {
	  conv_d(fname,flg);
	  done++;
	 }

	if(flg==4)      //utf8->s_jis
	 {
	  conv_utf(fname,flg); //utf8->shiftJis
	  done++;
	 }
	if(flg==5)     //s_jis->utf8
	 {
	  conv_utf(fname,flg); //utf8->shiftJis
	  done++;
	 }
	if(flg==6)     //euc_jp ->s_jis
	 {
	  conv_e(fname);
	  done++;
	 }

   }

  } //for

  if(eflg==0)
   {
	 msg=IntToStr(done)+msg;
	 Application->MessageBox(msg.c_str(),L"",0);
   }


Screen->Cursor=crArrow;
Form1->FileListBox1->Update();
}

BOOL CreateLink(LPTSTR lpszPathObj, LPSTR lpszPathLink)
//C++Builder ML̃R|h𗬗p
// LPTSTR  TCHAR*
// LPSTR   char *
//
{
	CoInitialize(NULL);

	IShellLink* psl;
	HRESULT hres = CoCreateInstance(
		CLSID_ShellLink,
		NULL,
		CLSCTX_INPROC,
		IID_IShellLink,
		(void **)&psl);

	if(SUCCEEDED(hres))
	{
		psl->SetPath(lpszPathObj);

		// Query IShellLink for the IPersistFile interface for saving the
		// shortcut in persistent storage.
		IPersistFile* ppf;
		hres = psl->QueryInterface(IID_IPersistFile, (LPVOID *)&ppf);

		if(SUCCEEDED(hres))
		{
			wchar_t wsz[MAX_PATH];

			// Ensure that the string is ANSI.
			MultiByteToWideChar(CP_ACP, 0, lpszPathLink, -1, wsz, MAX_PATH);

			// Save the link by calling IPersistFile::Save.
			hres = ppf->Save(wsz, TRUE);
			ppf->Release();
		}
		psl->Release();
	}

	CoUninitialize();
	if(SUCCEEDED(hres)) return TRUE;
	else return FALSE;
}



void MakeShortCut(int flg=0)
{
 AnsiString fname,lname,path;
 String w;
 int i,cnt;

 TCHAR szPath[_MAX_PATH];

 if((flg !=2)&&(flg !=3))
   { fname=Form1->FileListBox1->FileName;
	 if(fname=="")
	  {
		Application->MessageBox(L"t@CIĂ܂",L"",0);
		return;
	  }
	 lname=ExtractFileName(fname);
	 lname=ChangeFileExt(lname,".lnk");
   }
 else
   {
	cnt=Form1->ListBox1->Items->Count;
	for(i=0;i<cnt;i++)
	 {
	   if(Form1->ListBox1->Selected[i]==true)
		{
		  break;
		}
	 }
	if(i+1>cnt)
	 {
		Application->MessageBox(L"DirIĂ܂",L"",0);
		return;
	 }
   }
 switch(flg)
  {
   case 0: //݂Path
	path=ExtractFileDir(fname);
	if(path.Length()>3)
	 {
	  path=path+"\\";
	 }

	 lname=path+lname;
	 break;
   case 1: //desktop
	SHGetSpecialFolderPath(
		NULL,
		szPath,
		CSIDL_DESKTOPDIRECTORY,
		FALSE
		);
	path=szPath;
	lname=path+"\\"+lname;

	break;

   case 2: //dir shortcut
	fname=Form1->Label1->Caption;
	lname=ExtractFileName(fname);

	lname=ChangeFileExt(lname,".lnk");

	SHGetSpecialFolderPath(
		NULL,
		szPath,
		CSIDL_DESKTOPDIRECTORY,
		FALSE
		);
	path=szPath;
	lname=path+"\\"+lname;
	break;
   case 3: //dir shortcut
	fname=Form1->Label1->Caption;
	path=ExtractFileDir(fname);
	if(path.Length()>3)
	 {
	   path=path+"\\";
	 }
	lname=ExtractFileName(fname);
	lname=path+lname;
	lname=ChangeFileExt(lname,".lnk");

	break;
  }


  wchar_t* f = new wchar_t[fname.Length() + 2];
  wcscpy(f, UnicodeString(fname).c_str());
  f[wcslen(f) + 1] = 0;

 CreateLink(f,lname.c_str() );

 path=lname+"@쐬܂";
 w=path;

 Application->MessageBox(w.c_str(),L"",0);
}

String GetNetDrv(String d)
{
  wchar_t* b = new wchar_t[d.Length() + 2];
  wcscpy(b, UnicodeString(d).c_str());
  b[wcslen(b) + 1] = 0;

  String w;
  WCHAR a[255];
  w="z";
  DWORD dwSize = sizeof ( a );


  int s=WNetGetConnection(
  b,  // [Jւ̃|C^
  a,  // [g󂯎obt@ւ̃|C^
  &dwSize	   // obt@̃TCYi jւ̃|C^
  );

 w=a;
 return w;

}
String DiskChk(char c)
{
   String w,drv;
   int ExitFlg;

   Vol="";
   w="";
   drv="";

   drv=drv+c+":\\";
   if(GetDrvInfo(drv) !=-1)
	 {
		   w=" "+Vol;
		   w=w.SubString(1,8);
		   ExitFlg=1;
	 }
   else
	 {  ExitFlg=0; }

 return w;
}
/*
void SetDrv(TDriveComboBox *cbx)
{
 DWORD drv;
 UINT  type;
 int p,i,ii,remotPos,ndx;
 char c;
 String w,w1,RemoteDisk[20];

 ii=cbx->Items->Count;
 w=cbx->Text.SubString(1,1);

 for(i=0;i<ii;i++)
  {
   if(cbx->Items->Strings[i].SubString(1,1)==w)
	{
	 ndx=i;
	 break;
	}
  }

 remotPos=0;
 i=1;
 c='A';

 cbx->Items->Clear();
 drv=GetLogicalDrives();
 for(ii=0;ii<26;ii++)
  {
   p=drv & i; //a
   if(p >0)
	{
	 w=c;
	 w=w+":";
	 type=GetDriveType(w.c_str());
	 switch(type)
	  {
	   case 0:
		w=w+" ?";
		break;
	   case 1:
		w=w+" ?";
		break;
	   case DRIVE_REMOVABLE:
		if(c>'B')
		  w=w+" Rm";
		break;
	   case DRIVE_FIXED:
		w1=DiskChk(c);
		w=w+" ["+w1;
		w=w+" ]";
		break;
	   case DRIVE_REMOTE:
		RemoteDisk[remotPos++]=w;
		if(DirectoryExists(w)==true)
		 {
		  w=w.SubString(1,2)+GetNetDrv(w.SubString(1,2));
		 }
		break;
	   case DRIVE_CDROM:
		{
		  w1=DiskChk(c);
		  if(w1=="")
		   w=w+" [CDROM]";
		  else
		   w=w+w1;
		  break;
		}
	   case DRIVE_RAMDISK:
		w=w+" [RAM]";
		break;
	  }
	 cbx->Items->Add(w);
	}
   c++;
   i=i<<1;
  }
 cbx->ItemIndex=ndx;
}
*/

String ErrCode(int result) // SHFileOpG|
{
 String w;

 switch(result)
  {
	case 0x2:
	 w=L"ERROR_FILE_NOT_FOUND";
	 break;

	case 0x71:
	 w=L"DE_SAMEFILE";
	 break;
	case 0x72:
	 w=L"DE_MANYSRC1DEST";
	 break;
	case 0x73:
	 w=L"DE_DIFFDIR";
	 break;
	case 0x74:
	 w=L"DE_ROOTDIR";
	 break;
	case 0x75:
	 w=L"DE_OPCANNCELLED";
	 break;
	case 0x76:
	 w=L"DE_DESTSUBTREE";
	 break;
	case 0x78:
	 w=L"DE_ACCESSDENIEDSRC";
	 break;

	case 0x79:
	 w=L"DE_PATHTOODEEP";
	 break;
	case 0x7A:
	 w=L"DE_MANYDEST";
	 break;
	case 0x7C:
	 w=L"DE_INVALIDFILES";
	 break;
	case 0x7D:
	 w=L"DE_DESTSAMETREE";
	 break;
	case 0x7E:
	 w=L"DE_FLDDESTSFILE";
	 break;

	case 0x80:
	 w=L"DE_FILEDESTSFILE";
	 break;

	case 0x81:
	 w=L"DE_FILENAMETOOLONG";
	 break;
	case 0x82:
	 w=L"DE_DEST_IS_CDROM";
	 break;
	case 0x33:
	 w=L"DE_DEST_IS_DVD";
	 break;
	case 0x44:
	 w=L"DE_DEST_IS_CDRECORD";
	 break;
	case 0x85:
	 w=L"DE_FILE_TOO_LARGE";
	 break;
	case 0x86:
	 w=L"DE_SRC_IS_CDROM";
	 break;
	case 0x87:
	 w=L"DE_SRC_IS_DVD";
	 break;
	case 0x88:
	 w=L"DE_SRC_IS_CDRECORD";
	 break;

	case 0xB7:
	 w=L"DE_ERROR_MAX";
	 break;
	case 0x402:
	 w=L"unknown error";
	 break;
	case 0x10000:
	 w=L"ERONDEST";
	 break;
	case 0x10074:
	 w=L"DE_ROOTDIR";
	 break;

	default:
	 w=L"G|ԍ@"+IntToStr(result)+L" s̃G|";
	 break;
  }

 return w;
}
void ErrMsg(String w,int result)
{
 //M_Flg 4:MakeDir BackUpŎgp@

	 if(result !=0)
	  {
		w=ErrCode(result);
	  }

  Application->MessageBox(w.c_str(),L"",0);

  return;

}
void Fil_Execute(wchar_t *fname)
{
  wchar_t FNAME[256];
  wchar_t PARAM[256];

  SHELLEXECUTEINFO einfo;

  lstrcpy(FNAME,fname);

  lstrcpy(PARAM,L""); //KvȂ珈

  memset(&einfo,0,sizeof(einfo));
  einfo.cbSize=sizeof(einfo);
  einfo.lpVerb=L"open";
  einfo.lpFile=FNAME;
  einfo.lpParameters=PARAM;
  einfo.fMask=SEE_MASK_NOCLOSEPROCESS;
  einfo.nShow=SW_SHOWDEFAULT;

  ShellExecuteEx(&einfo);   //Api֐
}


class CDIR
{
 private:
  AnsiString srcp;
  int point,count,delcount;
  TSearchRec ts,ts1,ts2;
  int cnt;
  int bflg;
  struct SDPATH
   {
	 AnsiString src;
	 AnsiString dest;
   } sdpath[1000];
  struct INFO
   { int errcnt;
	 int newfilecount;
	 int oldfilecount;  //XV
	 int filecount;     //݂邆
	 int newdircount;
	 int olddircount;
	 int dircount;
	 int deldircount;
	 int delfilecount;
   }info;
  void push(AnsiString, AnsiString);
  int pop();

  int CmpFil(AnsiString,AnsiString);

  void destcheck(AnsiString, AnsiString);  //dirback
  void Init();  //backup Ŏgp

 public:
  CDIR() {  ; }

  int SHFileOp(AnsiString,AnsiString,int); //Del,Copy,Move

  int DirBackUp(AnsiString,AnsiString);
};

void CDIR::destcheck(AnsiString srcpath, AnsiString destpath)  //dirback
  {
	AnsiString w,w1,destp;

	srcp=srcpath;

	destp=destpath+"*.*";

	FindFirst(destp,faAnyFile,ts);
	 {
	  if(ts.Attr & 01)  {
	  ts.Attr=ts.Attr&0xffe;
	 }


	  if(ts.Attr== faDirectory)
	   {
		w=ts.Name;
		if((w !=".")&&(w !=".."))
		 {
		  w=srcpath+ts.Name;
		  w1=destpath+ts.Name;

		  cnt++;
		  if(DirectoryExists(w) ==false)
			{
			 if(SHFileOp(w1,"",0) !=0)   //del dir
			  {
				info.errcnt++;
			  }
			}
		  else
			{
				w=w+"\\";
				w1=w1+"\\";
				push(w,w1);
 			}

		 }
	   }
	  else  //File
	   {

		w=srcpath+w;
		w1=destpath+ts.Name;
		cnt++;
		Form1->Label6->Caption=IntToStr(cnt);
		if(FileExists(w) ==false)
		 {
		  if(SHFileOp(w1,"",0) !=0)   //del file
		   {
				info.errcnt++;
		   }
		 }
	   }

	 }

 while(FindNext(ts) ==0)
  {
   if(ts.Attr & 01)  {
   ts.Attr=ts.Attr&0xffe;
   }


   if(ts.Attr== faDirectory)
	{
	  w=ts.Name;
	  if((w !="..")&&(w != "."))
		{
		  w=srcpath+ts.Name;
		  w1=destpath+ts.Name;
		  cnt++;
		  Form1->Label6->Caption=IntToStr(cnt);

		  if(DirectoryExists(w) ==false)
			{
			 if(SHFileOp(w1,"",0) !=0)   //del dir
			  {
				info.errcnt++;
			  }
			}
		  else
			{
			  w=w+"\\";
			  w1=w1+"\\";
			  push(w,w1);

			}

		}

	}
   else  //File
	{

	 w=srcpath+ts.Name;
	 w1=destpath+ts.Name;

   //CopŷebɂȂ΍폜
	 cnt++;
	 if(FileExists(w) ==false)
	  {
	   if(SHFileOp(w1,"",0) !=0)   //del file
		 {
		   info.errcnt++;
		 }
	  }

	}
  }

 FindClose(ts);

 return;

}


void CDIR::Init()
{
 bflg=0;
 cnt=0;
 point=0;
 count=0;
 delcount=0;
 info.errcnt=0;
 info.newfilecount=0;
 info.oldfilecount=0;
 info.newdircount=0;
 info.olddircount=0;
 info.filecount=0;
 info.dircount=0;
 info.deldircount=0;
 info.delfilecount=0;
}


void CDIR::push(AnsiString SPath0,AnsiString DPath0)
{
 sdpath[point].src=SPath0;
 sdpath[point++].dest=DPath0;

}

int CDIR::pop()
{
 return --point;

}
int CDIR::SHFileOp(AnsiString Dir,AnsiString Dir1,int flg) //Del,Copy,Move
{
 String w;

/*
typedef struct _SHFILEOPSTRUCT {
    HWND  hwnd;                 // EBhEnh
    UINT  wFunc;                // s鑀
    LPCTSTR  pFrom;             // Ώۃt@C
    LPCTSTR  pTo;               // ړIt@C
    FILEOP_FLAGS  fFlags;       // tO
    BOOL fAnyOperationsAborted; // 
    LPVOID  hNameMappings;      // t@C}bsOIuWFNg
    LPCTSTR lpszProgressTitle;  // _CAÕ^Cg
} SHFILEOPSTRUCT, FAR *LPSHFILEOPSTRUCT;

    Version 4.71 ȍ~F t@C̃ZLeBRs[Ȃ悤ɂ܂B
	0x1000 (FOF_NORECURSION)
*/

   //\ŏIĂƍ폜łȂ̂ōṒ폜
  Dir = ExcludeTrailingPathDelimiter(Dir);
  Dir1 = ExcludeTrailingPathDelimiter(Dir1);
/*
   wchar_t* buff = new wchar_t[pathSize]; //[m
  wcscpy(buff, targetDir.c_str());
  buff[pathSize-1] = 0;
*/

  //I[\0\0
  wchar_t* from = new wchar_t[Dir.Length() + 2];
  wcscpy(from, UnicodeString(Dir).c_str());
  from[wcslen(from) + 1] = 0;

  wchar_t* to = new wchar_t[Dir1.Length() + 2];
  wcscpy(to, UnicodeString(Dir1).c_str());
  to[wcslen(to) + 1] = 0;


  SHFILEOPSTRUCT fs;
  ZeroMemory(&fs, sizeof(SHFILEOPSTRUCT));
  fs.hwnd = Application->Handle;
  fs.fFlags = FOF_NORECURSION;

  switch(flg)
   {
	 case 0: //Del
	  fs.wFunc = FO_DELETE;
	  w="폜";
	  break;
	 case 1: //Copy
	  fs.wFunc = FO_COPY;
	  w="Rs[";
	  break;
	 case 2: //Move
	  fs.wFunc = FO_MOVE;
	  w="ړ";
	  break;
	 case 3:
	  fs.wFunc = FO_RENAME;
	  w="qdm`ld";
	  break;
   }


  fs.pFrom=from;
  fs.pTo = to;

/*
FOF_NOCONFIRMMKDIR : VfBNg쐬KvꍇɁA쐬邩ǂ̊mF܂B
FOF_SIMPLEPROGRESS : o߂\_CAO{bNXɃt@C\܂B
FOF_NOCONFIRMATION : \_CAO{bNXŁw͂x܂́wׂāxI悤ɂ܂B

*/

  fs.fFlags=FOF_SIMPLEPROGRESS|FOF_NOCONFIRMATION|FOF_NOCONFIRMMKDIR;

  int result=0;
  result = SHFileOperation(&fs);  //0.. successful

  if(result==0) { Form1->Label10->Caption=from+w; }
  else { { Form1->Label10->Caption="error"; }
  }

  delete[] from;
  delete[] to;

  if(result !=0)
   {
	w=ErrCode(result)+" : "+Dir+"   ::  "+Dir1;
    ShowMessage(w);
   }
  return result;
}

int CDIR::CmpFil(AnsiString fname,AnsiString fname1) //FileAgeŏ肭`FbNoȂ̂ō쐬
											   //b܂Ń`FbN@@
											   //return fname̎-fname1̎ 0Ȃ瓯
{
 TSearchRec ts,ts1;

 int cmp;
 WIN32_FIND_DATAW FileData1;

/*
typedef struct _WIN32_FIND_DATA { // wfd
	DWORD dwFileAttributes;
	FILETIME ftCreationTime;
	FILETIME ftLastAccessTime;
	FILETIME ftLastWriteTime;
	DWORD    nFileSizeHigh;
	DWORD    nFileSizeLow;
	DWORD    dwReserved0;
	DWORD    dwReserved1;
	TCHAR    cFileName[ MAX_PATH ];
	TCHAR    cAlternateFileName[ 14 ];
} WIN32_FIND_DATA;

 struct TSearchRec

{
	int Time;
	int Size;
	int Attr;
	AnsiString Name;
	int ExcludeAttr;
	int FindHandle;
	_WIN32_FIND_DATAA FindData;
} ;

*/

 char w[255],w1[255];
 SYSTEMTIME sysTime,sysTime1;
 FILETIME fLocalTime,fLocalTime1;

 FindFirst(fname,faAnyFile,ts);
 FindFirst(fname1,faAnyFile,ts1);

 GFileData=ts.FindData ;     //tv̂Ɏgp
 FileData1=ts1.FindData;    //


 FileTimeToLocalFileTime(&GFileData.ftLastWriteTime,&fLocalTime);
 FileTimeToSystemTime(&fLocalTime,&sysTime);

 FileTimeToLocalFileTime(&FileData1.ftLastWriteTime,&fLocalTime1);
 FileTimeToSystemTime(&fLocalTime1,&sysTime1);

 cmp=sysTime.wYear-sysTime1.wYear;
 if(cmp !=0) goto ret;

 cmp=sysTime.wMonth-sysTime1.wMonth;
 if(cmp !=0) goto ret;

 cmp=sysTime.wDay-sysTime1.wDay;
 if(cmp !=0) goto ret;

 cmp=sysTime.wHour-sysTime1.wHour;

 if(cmp !=0) goto ret;

 cmp=sysTime.wMinute-sysTime1.wMinute;
 if(cmp !=0) goto ret;

 cmp=sysTime.wSecond-sysTime1.wSecond;

ret:
 FindClose(ts);
 FindClose(ts1);

 return cmp;
}

int CDIR::DirBackUp(AnsiString SPath,AnsiString DPath)
{
  Flg=0;

  int i,len;
  AnsiString c,w,src,dest;

  src=SPath;
  dest=DPath;
  len=SPath.Length();
  for(i=len-1;i>0;i--)
   {
	 c=SPath.SubString(i,1);
	 if(c == "\\")
	  {
       DPath=DPath+SPath.SubString(i,len-i+1);
	   break;
      }
   }

  CDIR::Init();
  CDIR::push(SPath,DPath);

  while(point>0)
   {

	CDIR::destcheck(SPath,DPath);

	Form1->Label5->Caption=IntToStr(info.errcnt);

	Form1->Label5->Update();
	Form1->Label6->Update();

	point=CDIR::pop();

	SPath=sdpath[point].src;
	DPath=sdpath[point].dest;
   }

  SHFileOp(src,dest,1);
  return info.errcnt;
}


//-- CDIR̒`@dmc@ --------------------------------------------------------
//
//
//////////////////////---DirBox --////////////////////////////////////////////////

class DirBox
{
 private:
  String drv,w,w1,dir;
  int i,ii,len,flg,ndx,total;


  TSearchRec ts;
  int hflg;
  int mflg;
  int Sp_Dir;
  String Path,Sp,SubPath[10];

  TListBox *dbox;
  TFileListBox *fbox;
  TLabel *label1;
  TLabel *label8;

  String DirBox::set_sp(int len)
	{
	  Sp="";
	  for(ii=0;ii<len;ii++)
	   {
         Sp=Sp+"  ";
	   }
	  return Sp;
	}

 public:
  DirBox(){ hflg=0; mflg=0; }
  void GetPath();
  void SetBox( TListBox *p, TFileListBox *p1);
  void DrvChg(TDriveComboBox *);
  void SetHidden(TCheckBox *);

  void SetLabel1(TLabel *);
  void SetLabel8(TLabel *);

  void SetMulti(TCheckBox *);
  void ChgPath();
  void MultiSelect();
  void dirdisp();
};

//----------------------`--------------------------------
void DirBox::SetLabel8(TLabel *c)
 {
   label8=c;
 }

void DirBox::SetLabel1(TLabel *c)
 {
   label1=c;
 }


void DirBox::MultiSelect()  //̃pXIȂ悤ɂ
{
 total=dbox->Count;
 if(mflg==255)
  {
	for(i=0;i<total;i++)
	 {
	   if(dbox->Selected[i]==true)
		{
		  if(i<=Sp_Dir)
		   {
			dbox->Selected[i]=false;
		   }
		}
	 }
  }
}
void DirBox::GetPath()     //Label1,8 ɃpXZbg
{
  Path="";
  for(i=0;i<=Sp_Dir;i++)
	 {
	   Path=Path+SubPath[i];
	 }
   label8->Caption=Path;     // select Dir

  if(dbox->ItemIndex<=Sp_Dir)
   {
	label1->Caption=Path;    // current Dir
   }
  else
   {
	label1->Caption=Path+dbox->Items->Strings[dbox->ItemIndex].Trim();

   }
 return;
}
void DirBox::ChgPath()
{
 dir="";
 ndx=dbox->ItemIndex;
 Path="";

 if(ndx>Sp_Dir)
  {
//   path
//     sp path
//     sp sp path
//   Sp_Dir@̓pX̑OɏAĂXy[X̐ێAItemIndex Ɠ


	for(i=0;i<=Sp_Dir;i++)
	 {
	   Path=Path+SubPath[i];
	 }
	dir=dbox->Items->Strings[ndx].Trim();

	Sp_Dir++;
	SubPath[Sp_Dir]=dir+"\\";
	label1->Caption=Path+dir;
	Path=Path+dir+"\\";
  }

 else
  {
  //path Iꂽ̏

   for(i=0;i<=ndx;i++)
	{
	  Path=Path+SubPath[i];
	  label1->Caption=Path;
	  Sp_Dir=ndx;
	}
  }

 label8->Caption=Path;

  DirBox::dirdisp();
}


void DirBox::SetHidden(TCheckBox *c)
{
  if(c->Checked==true)
   {
	 hflg=255;
	 fbox->FileType<<ftHidden;

   }
  else
   {
	 hflg=0;
	 fbox->FileType>>ftHidden;
   }
  DirBox::dirdisp();
}


void DirBox::SetMulti(TCheckBox *c)
{
  if(c->Checked==true)
   {
	 mflg=255;
	 dbox->MultiSelect=true;
   }
  else
   {
	 mflg=0;
	 dbox->MultiSelect=false;
   }
}

void DirBox::SetBox(TListBox *p, TFileListBox *p1)
{
 dbox=p;
 fbox=p1;
}

void DirBox::dirdisp()
{
 String sd[200];

 total=0;

 for(i=0;i<200;i++)
  {
   sd[i]="";

  }

 w1="";

 for(i=0;i<=Sp_Dir;i++)
  {
   Sp=DirBox::set_sp(i);
   len=SubPath[i].Length();
   w=SubPath[i].SubString(1,len-1);
	 sd[total++]=Sp+w;
  }

 fbox->Directory=Path.c_str();

 FindFirst(Path+"*",faAnyFile,ts);
 w=" "+ts.Name;
 w1=Path+ts.Name;



 if(hflg==0)
   {
	 if(((ts.Attr & 0x10)==faDirectory) & ((ts.Attr & faHidden) != faHidden) )
	   {
		if(ts.Name !="." && ts.Name !="..")
		 {

		   if(DirectoryExists(w1)==true)
			{
			 sd[total++]=Sp+w;
			}
		 }
	   }
   }
 else
   {
	 if( ((ts.Attr& 0x10)==faDirectory) || (((ts.Attr & 0x10)==faDirectory) &&((ts.Attr & faHidden)==faHidden)))
	  {
		if(ts.Name !="." && ts.Name !="..")
		 {
		   if(DirectoryExists(w1)==true)
			{
			 sd[total++]=Sp+w;
			}
		 }
	  }
   }

 while(FindNext(ts) ==0)
  {
   w=" "+ts.Name;
   w1=Path+ts.Name;

   if(hflg==0)
	{
	 if(((ts.Attr & 0x10)==faDirectory) & ((ts.Attr & faHidden) != faHidden))
	  {
	  if(ts.Name !="." && ts.Name !="..")
	   {
		   if(DirectoryExists(w1)==true)
			{
			 sd[total++]=Sp+w;
			}
	   }
	  }

	}
   else
	{
	 if( ((ts.Attr & 0x10)==faDirectory) || (((ts.Attr & 0x10)==faDirectory) &&((ts.Attr & faHidden)==faHidden)))
	  {
	  if(ts.Name !="." && ts.Name !="..")
	   {
		   if(DirectoryExists(w1)==true)
			{
			 sd[total++]=Sp+w;
			}
	   }
	  }
	}
  }
 if(total>0)
  {
	for(i=Sp_Dir+1;i<total;i++)
	  {
		for(ii=i+1;ii<total;ii++)
		  {
			if(sd[i].LowerCase()>sd[ii].LowerCase())
			 {
			   w=sd[i];
			   sd[i]=sd[ii];
			   sd[ii]=w;
			 }
		  }
	  }
  }

 dbox->Clear();

 for(i=0;i<total;i++)
  {
   dbox->Items->Add(sd[i]);
  }

 dbox->ItemIndex=Sp_Dir;  //Sp_Dir̓pX̑Oɂr̐
 fbox->Update();
}

void DirBox::DrvChg(TDriveComboBox *d)
{
  drv=d->Text.SubString(1,2)+"\\";

  Sp_Dir=0;
  SubPath[Sp_Dir]=drv;
  Path=drv;
  fbox->Directory=Path;
  label1->Caption=Path;
  label8->Caption=Path;

  DirBox::dirdisp();
}

//////////////////////////////////  DirBox END /////////////////////////////////

DirBox dbox1,dbox2;
CDIR cdir;

void __fastcall TForm1::FormCreate(TObject *Sender)
{
  dbox1.SetBox(ListBox1, FileListBox1);
  dbox1.SetLabel1(Label1);
  dbox1.SetLabel8(Label8);

}
//---------------------------------------------------------------------------
void __fastcall TForm1::DriveComboBox1Change(TObject *Sender)
{
 dbox1.DrvChg(DriveComboBox1);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::CheckBox1Click(TObject *Sender)
{
 dbox1.SetHidden(CheckBox1);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CheckBox2Click(TObject *Sender)
{
 dbox1.SetMulti(CheckBox2);
}
//---------------------------------------------------------------------------


void __fastcall TForm1::ListBox1DblClick(TObject *Sender)
{
 dbox1.ChgPath();

}
//---------------------------------------------------------------------------

void __fastcall TForm1::ListBox1MouseUp(TObject *Sender, TMouseButton Button, TShiftState Shift,
		  int X, int Y)
{
  dbox1.MultiSelect();
}

//---------------------------------------------------------------------------

 int filecopy(int mode) //file copy,move   path͂
{
 String fname,fname1,fname2,w,path,path1,ext;
 int i,cnt,Total,result;

 cnt=0;
 Screen->Cursor=crHourGlass;

 Total=Form1->FileListBox1->Count;

 // PATH0  src path
 i=PATH0.Length();
 if(PATH0.SubString(i,1) !="\\")
  {
	PATH0=PATH0+"\\";
  }

 for(i=0;i<Total;i++)
  {
   if(Form1->FileListBox1->Selected[i]==true)
	{
	 fname=PATH0+Form1->FileListBox1->Items->Strings[i];

	 switch(mode)
	 {
	  case 4: //file copy
	   fname1=PATH1+Form1->FileListBox1->Items->Strings[i];

	   result=cdir.SHFileOp(fname,fname1,1);

	   break;

	  case 5: //move
	   fname1=PATH1+Form1->FileListBox1->Items->Strings[i];
	   result=cdir.SHFileOp(fname,fname1,2);
	   break;

	  case 6: //file del

	   result=cdir.SHFileOp(fname,"",0);

	   break;

	  case 7: //File Ren
	   ext=ExtractFileExt(fname);

	   if(EXT !="")
		{
		 fname1=PATH0+FNAME+EXT;
		}
	   else
		{
		 fname1=PATH0+FNAME+ext;
		}
	   if(cnt>0)
		{
		 if(EXT !="")
		   { fname1=PATH0+FNAME+IntToStr(cnt+1)+EXT;
		   }
		 else
		   {
			 fname1=PATH0+FNAME+"-"+IntToStr(cnt+1)+ext;
		   }

		}

	   result=cdir.SHFileOp(fname,fname1,3);

	   cnt++;
	   break;
	  case 8: //啶
	   fname1=fname.UpperCase();
	   result=cdir.SHFileOp(fname,fname1,3);
	   break;
	  case 9: //
	   fname1=fname.LowerCase();
	   result=cdir.SHFileOp(fname,fname1,3);
	   break;
	  case 10: //DUP
	   fname2=Form1->FileListBox1->Items->Strings[i];
	   ext=ExtractFileExt(fname2);
	   fname2=fname2.SubString(1,fname2.Length()-ext.Length());

	  while(cnt<DUP_CNT)
		{
		 fname1=fname2+"0"+IntToStr(cnt++)+ext;
		 fname1=PATH1+fname1;
		 result=cdir.SHFileOp(fname,fname1,1);
		}
	   break;
	 }
	}
   }
 if(result !=0)
  {
	Err++;
  }
 Form1->FileListBox1->Update();
 Screen->Cursor=crArrow;
 return result;
}

void __fastcall TForm1::N3Click(TObject *Sender) //FileRename
{
  String w,src,dest;
  int result,i;

  M_FLG=13; //File Ren
  Form3->ShowModal();
  if(FNAME=="")
   {
	 return;
   }

   i=PATH0.Length();
   if(PATH0.SubString(i,1) !="\\")
	{
	  PATH0=PATH0+"\\";
	}

  w=PATH0+FNAME+EXT;
  if(FileExists(w))
   {
	 return;
   }


  result=filecopy(7);
  FileListBox1->Update();

}
//---------------------------------------------------------------------------

void __fastcall TForm1::N1Click(TObject *Sender)  //FileCopy
{
  int result;

  M_FLG=11;    //File Copy

  Form2->Caption="e@b";

  Form2->ShowModal();
  if(PATH0=="") return;

  Err=0;

  result=filecopy(4);  //file copy


  ErrMsg(L"ẽRs|I܂",result);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N5Click(TObject *Sender)  //File Del
{
  String w,ext;

  int result;
  M_FLG=10;  //File Del

/*
 if(Application->MessageBox(L"File폜܂",L"",1)==2)
  {
	 Application->MessageBox(L"File̍폜LZ܂",L"",0);
	 return;
  }
*/

 w= FileListBox1->FileName;
 PATH0=ExtractFileDir(FileListBox1->FileName);

 Err=0;

 result=filecopy(6); //File Del

 ext=ExtractFileExt(w);
 ext=ext.LowerCase();
 if(ext==".ico")
  {
	Image1->Visible=false;
  }


 FileListBox1->Update();

 ErrMsg("File̍폜܂",result);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::N2Click(TObject *Sender)  //File Move
{
  int result;

  M_FLG=12; //File Move

  Form2->Caption="e@Move";
  Form2->ShowModal();
  if(PATH0=="") return;

  Err=0;

  result=filecopy(5);  //file copy

  ErrMsg(L"ëړI܂",result);
}
//---------------------------------------------------------------------------
int GetDrvInfo(String &drv)
{
	String path = drv;
	DWORD serialnumber;
	DWORD maxcomponentlength;
	DWORD flags;
	TCHAR volume[256];

	String filesystem;
    filesystem.SetLength(256);

	wchar_t* PATH=new wchar_t[path.Length()+2];
	wcscpy(PATH, UnicodeString(drv).c_str());
	Vol="";

	if (GetVolumeInformation(path.c_str(), volume, 256,
							 &serialnumber, &maxcomponentlength, &flags,
							 filesystem.c_str(), filesystem.Length()))

	 {
	  Vol=volume;
	  return 1;
	 }
	else
	 {
	  return -1;
	 }

}


void __fastcall TForm1::DriveComboBox1Click(TObject *Sender)
{
int i,n;
String drv;
drv=DriveComboBox1->Text.SubString(1,2);
drv=drv+"\\";

 if(GetDrvInfo(drv)==-1)
  {
   Application->MessageBox(L"fBA}Ă܂",L"",0);
   drv=Form1->ListBox1->Items->Strings[0];

   n=Form1->DriveComboBox1->Items->Count;
   for(i=0;i<n;i++)
	{

	 if(Form1->DriveComboBox1->Items->Strings[i].SubString(1,2).LowerCase()==drv.LowerCase())
	  {
	   Form1->DriveComboBox1->ItemIndex=i;
	   break;
	  }
	}
  }
}

//---------------------------------------------------------------------------
 int dircopy(int mode) //dir del,ren,copy,move   path͂
{
 AnsiString dname,dname1,dname2,w,path,path1;
 int i,cnt,Total,result;

 result=0;
 cnt=0;
 Screen->Cursor=crHourGlass;

 Total=Form1->ListBox1->Count;

 path=ExtractFilePath(Form1->Label1->Caption);
 PATH0=ExtractFilePath(PATH0);

 for(i=0;i<Total;i++)
  {
   if(Form1->ListBox1->Selected[i]==true)
	{
	 dname=path+Form1->ListBox1->Items->Strings[i].Trim()+"\\";

	 switch(mode)
	 {
	  case 4: //Dir Copy
	   dname1=PATH1;
	   result=cdir.SHFileOp(dname,dname1,1);

	   break;
	  case 5: //Dir Move
		dname1=PATH1;
		result=cdir.SHFileOp(dname,dname1,2);

	   break;

	  case 6: //dir del
	   result=cdir.SHFileOp(dname,"",0);

	   break;

	  case 7: //dir Ren
	   if(cnt>0)
		{
		 dname1=path+FNAME+"_"+IntToStr(cnt);
		}
	   else
		{
		 dname1=path+FNAME;
		}
	   result=cdir.SHFileOp(dname,dname1,3);

	   cnt++;
	   break;
	  case 8:  //UperCase
		dname1=dname.UpperCase();
		dname1=ExtractFileDir(dname1);
		result=cdir.SHFileOp(dname,dname1,3);
	    break;
	  case 9:  //LowerCase
		dname1=dname.LowerCase();
		dname1=ExtractFileDir(dname1);
		result=cdir.SHFileOp(dname,dname1,3);
		break;
	 }

	if(result !=0)
	 {
	  Err++;
	  w="G|܂";
	  ErrMsg(w,result);
	  break;

	 }
   }

  }


 dbox1.dirdisp();
 Screen->Cursor=crArrow;
 return result;
}

void __fastcall TForm1::N8Click(TObject *Sender)
{
  String w,dest,src;
  int result;

  M_FLG=3; //Dir Ren
  Form3->ShowModal();
  if(FNAME=="")  //Cancel
   {
	return;
   }

  result=dircopy(7);   //Dir Ren

}
//---------------------------------------------------------------------------

void __fastcall TForm1::ListBox1Click(TObject *Sender)
{

  dbox1.GetPath();

  Label10->Caption="";

  Image1->Visible=false;

}
//---------------------------------------------------------------------------

void __fastcall TForm1::N6Click(TObject *Sender) //Dir Copy
{
	UnicodeString w;
   int result;

   M_FLG=1;

   Form2->Caption="c@b";

   Form2->ShowModal();

   if(PATH1=="") return; //Cancel
   w=PATH0+""+PATH1+"փRs|܂";


   if(Application->MessageBox(w.c_str(),L"",1)==2)
	{
	 Application->MessageBox(L"c̃Rs|LZ܂",L"",0);
	 return;
	}

   Err=0;

   result=dircopy(4);

   w=PATH0+"̃Rs|I܂";
   ErrMsg(w,result);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::N11Click(TObject *Sender) // Dir Del
{
  UnicodeString w;
  int result;

  M_FLG=0;

  if(Label1->Caption.SubString(Label1->Caption.Length(),1)=="\\")
	PATH0=Label1->Caption;
  else
	PATH0=Label1->Caption+"\\";

  w=PATH0+"폜܂";

  if(Application->MessageBox(w.c_str(),L"",1)==2)
	{
	 Application->MessageBox(L"c̍폜LZ܂",L"",0);
	 return;
	}
 Err=0;

 result=dircopy(6);  //Dir Del
 if(Err>0)
  {

   Application->MessageBox(L"G|܂",L"",0);
  }
 else
  {
	dbox1.dirdisp();
	w=PATH0+"폜܂";
	ErrMsg(w,result);
  }

}
//---------------------------------------------------------------------------

void __fastcall TForm1::N7Click(TObject *Sender)   // Dir Move
{
   UnicodeString w;
   int result;

   M_FLG=2; //dir move
   Form2->Caption="c@Move";
   Form2->ShowModal();

   if(PATH1=="")  //Cancel
   {
	return;
   }

   w=PATH0+""+PATH1+"ֈړ܂";

   if(Application->MessageBox(w.c_str(),L"",1)==2)
	{
	 Application->MessageBox(L"c̈ړLZ܂",L"",0);
	 return;
	}

  Err=0;

  result=dircopy(5);   //Dir Move

  w=PATH0+"̈ړI܂";
  ErrMsg(w,result);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::N12Click(TObject *Sender)  //Make Dir
{
  String w;
  int i;

  if(ListBox1->ItemIndex==-1)
   {
    Application->MessageBox(L"cIĉ",L"",0);
	return;
   }
  M_FLG=30;


  Form3->ShowModal();

  if(FNAME=="")
   return;
  if(DirectoryExists(FNAME)==true)
   {
	 ErrMsg("̃tI_[łɂ܂",0);
	 return;
   }

  if(CreateDirectory(FNAME.c_str(),NULL) ==0)
   {
	ErrMsg("쐬o܂ł@I",0);
    return;
   }

  dbox1.dirdisp();
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Option2Click(TObject *Sender) //DirBackUp
{
  String dir0,dir1,w,w1,c;
  int result,i,len;

  M_FLG=4;  //Dir BackUp

  Form2->Caption="c@at";

  Form2->ShowModal();
  if(PATH1=="")
   {
	 return;
   }

	  dir0=Label1->Caption+"\\";
	  dir1=PATH1;

	 Label9->Visible=true;
	 Label4->Visible=true;
	 Label5->Visible=true;
	 Label6->Visible=true;
	 Label4->Caption="G|";
	 Label7->Visible=true;
	 Label10->Visible=true;

	 Form1->Update();
	 w=Trim(ListBox1->Items->Strings[ListBox1->ItemIndex]);

	 w=PATH1+w;
	 if(DirectoryExists(w) ==false) // ȂƃG[
	  {
	   CreateDir(w);
	  }


	 result=cdir.DirBackUp( dir0, dir1);     //info.errcntԂ

	 Label6->Caption=IntToStr(result);
	 ErrMsg("obNAbvI܂",result);

	 Label4->Visible=false;
	 Label5->Visible=false;
	 Label6->Visible=false;
	 Label7->Visible=false;

	 Label9->Visible=false;
	 Label10->Visible=false;

}
//---------------------------------------------------------------------------


void __fastcall TForm1::FileListBox1DblClick(TObject *Sender) //file excute
{
  AnsiString ext;


  ext=ExtractFileExt(FileListBox1->FileName);
  ext=ext.LowerCase();

  if(ext !=".ico")
   {
	 Fil_Execute(FileListBox1->FileName.c_str());
   }
  else
   {
	 icon_disp(FileListBox1->FileName);
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormActivate(TObject *Sender)
{
 String dir1;
 int i,n;

 Label4->Visible=false;
 Label5->Visible=false;
 Label6->Visible=false;
 Label9->Visible=false;


 dir1=Application->ExeName.SubString(1,1);
 n=Form1->DriveComboBox1->Items->Count;
 for(i=0;i<n;i++)
	{

	 if(Form1->DriveComboBox1->Items->Strings[i].SubString(1,1).LowerCase()==dir1.LowerCase())
	  {
	   Form1->DriveComboBox1->ItemIndex=i;
	   break;
	  }
	}

 dbox1.DrvChg(DriveComboBox1);
 ListBox1->SetFocus();

 Form1->ListBox1->ScrollWidth=1800;
 Form1->FileListBox1->ScrollWidth=1200;

}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormResize(TObject *Sender)
{

 Form1->Width=920;
 Form1->Height=490;
 Image1->Left=830;

 ListBox1->Width=442;
 ListBox1->Height=311;
 ListBox1->Top=34;
 ListBox1->Left=5;

 FileListBox1->Width=442;
 FileListBox1->Height=311;
 FileListBox1->Left=ListBox1->Left+ListBox1->Width+5;
 FileListBox1->Top=ListBox1->Top;

 DriveComboBox1->Top=5;
 DriveComboBox1->Left=5;


 FilterComboBox1->Left=DriveComboBox1->Left+200;
 FilterComboBox1->Top=DriveComboBox1->Top;
 FilterComboBox1->Height=DriveComboBox1->Height;
 FilterComboBox1->Width=200;

 CheckBox2->Left= FilterComboBox1->Left+FilterComboBox1->Width+150;
 CheckBox2->Top=DriveComboBox1->Top+5;

 CheckBox1->Left=CheckBox2->Left+ CheckBox2->Width+10;
 CheckBox1->Top=CheckBox2->Top;

 CheckBox3->Left= CheckBox1->Left+CheckBox1->Width+10;
 CheckBox3->Top= CheckBox2->Top-2;


Image1->Top= ListBox1->Top+FileListBox1->Height+10;

}
//---------------------------------------------------------------------------

void __fastcall TForm1::N13Click(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N15Click(TObject *Sender)  //ڑ
{
  WNetConnectionDialog(NULL, RESOURCETYPE_DISK);

//  SetDrv(DriveComboBox1);
  ListBox1->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::N16Click(TObject *Sender)    //ؒf
{
  WNetDisconnectDialog(NULL, RESOURCETYPE_DISK);
  ListBox1->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N17Click(TObject *Sender)  //UperCase
{
  PATH0=Label1->Caption;
  filecopy(8);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N18Click(TObject *Sender)  //LowerCase
{
  PATH0=Label1->Caption;
  filecopy(9);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N21Click(TObject *Sender)
{
  PATH0=Label1->Caption;
  dircopy(8);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N22Click(TObject *Sender)
{
   PATH0=Label1->Caption;
   dircopy(9);
}
//---------------------------------------------------------------------------


void __fastcall TForm1::N24Click(TObject *Sender)     //shortcut desktop
{
 MakeShortCut(1);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N25Click(TObject *Sender)     //shortcut same dir
{
 MakeShortCut(0);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N27Click(TObject *Sender)  //Same Dir
{
  MakeShortCut(2);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N28Click(TObject *Sender) //dir DeskTop
{
  MakeShortCut(3);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N29Click(TObject *Sender) //DUP
{
  int result;

  M_FLG=20;    //File DUP

  Form2->Caption="tAC@";

  Form2->ShowModal();
  if(PATH0=="") return;

  result=filecopy(10);  //file dup

  ErrMsg(L"e̕ʂI܂",result);

}
//---------------------------------------------------------------------------


void __fastcall TForm1::N31Click(TObject *Sender)   //0A->0A0D
{
  conv(3);  //0A->0A0D
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N32Click(TObject *Sender)
{
  conv(0);  //0A0D->0A
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N34Click(TObject *Sender)
{
   Form4->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::BSCUT1Click(TObject *Sender)
{
 conv(2);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ESCCUT1Click(TObject *Sender)
{
  conv(1);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N39Click(TObject *Sender)
{
  Form5->ShowModal();
//  SetDrv(DriveComboBox1);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N38Click(TObject *Sender)
{
   Form6->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::UTF8SJIS1Click(TObject *Sender)
{
   conv(4);       //utf8->s_jis
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SJISUTF81Click(TObject *Sender)
{
//	conv(5);      //s_jis->utf8
 ShowMessage("HAgps\@I");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::EUCSJIS1Click(TObject *Sender)
{
	conv(6);  //euc->s_jis
}
//---------------------------------------------------------------------------


void __fastcall TForm1::FileListBox1Click(TObject *Sender)
{
  AnsiString ext;
  ext=ExtractFileExt(FileListBox1->FileName);
  ext=ext.LowerCase();
  TRect rect(0,70,0,70);

 Label10->Caption="";

 if ((ext !=".ico")&&(ext!=".exe")&&(ext!=".dll"))
	 {

	 Graphics::TBitmap *bmp;
	 bmp=new Graphics::TBitmap;

	 bmp->Width=80;
	 bmp->Height =80;

	 Form1->Image1->Canvas->StretchDraw(Rect(1,1,80,80),bmp);

	 Image1->Refresh();

	 delete bmp;
	 Image1->Visible=false;

	 }
  else
	 {
		 icon_disp(FileListBox1->FileName);
     }

}
//---------------------------------------------------------------------------

